> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Export bulk PDF files

POST https://rest.test.zuora.com/v1/operations/bulk-pdf
Content-Type: application/json

The background job that compresses large number of PDF(s) into ZIP files. For answers to frequently asked questions regarding exporting bulk PDF files, see Export Bulk PDF Files FAQs.
**Note**: Do not include multiple objectIds with the same PDF file names in a single bulk PDF upload request.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/operations/create-bulk-pdf-to-zip-generation

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTBulkPdfGenerationJobRequestType.

- `documents` (list of DocumentList, required) — An array that contains a collection of objects where each object contains billing document type and their IDs.
- `fileName` (string, required) — The prefix part of output file name(s). The response will include multiple file URLs. The number of zip files generated corresponds to the number of invoice IDs. Each zip file contains up to 1000 document IDs. Eg: if fileName is "all-invoices-posted-jan-2024" then fileURL(s) will start with the file name followed by an underscore and a number. For instance, all-invoices-posted-jan-2024_1.zip, all-invoices-posted-jan-2024_2.zip, and so on.
- `indexFileFormat` (enum, required) — The format of the index file. It contains the metadata about the files and their contents.
  - Allowed values: `JSON`, `CSV`
- `name` (string, optional) — The name of the job.
- `generateMissingPDF` (boolean, optional) — This flag controls the behavior of whether to generate PDF(s) for billing documents that do not already have one. - setting it to true indicates service would go through the provided document ID list, find the billing documents that do not have a generated PDF, generate them all at once, and then proceed to the zipping process. - setting it to false indicates service would go through the provided document ID list, find the billing documents that do not have a generated PDF, mark them as Invalid, and skip them from the zipping process. IDs marked as invalid will be included in the response. The default value is false.
- `ignoreArchivedFiles` (boolean, optional) — Ignores archived PDF files during export without causing the entire job request to fail when enabled.
- `persistIndexFile` (boolean, optional) — Controls the generation of the index file, allowing you to efficiently handle high volumes of requests. By default, this field is set to `true`. - When set to `true`, the index file is generated and included in the zip file. - When set to `false`, the index file is not generated and consequently not included in the zip file.

## Response

### 200

OK

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of PostBulkPdfGenerationJobResponseTypeReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.
- `jobId` (string, optional) — Unique Id for the Job Triggered.
- `invalidIds` (any, optional) — Collection of Ids that are not valid. Id is considered to be invalid if, * Billing Document Id doesn't exist in the database for the corresponding Billing Document Type * generateMissingPDF property is false in the Job Request and Valid PDF doesn't exist for the Billing Document Id
- `skippedDocuments` (list of PostBulkPdfGenerationJobResponseTypeSkippedDocumentsItems, optional) — The `skippedDocuments` array will be empty unless archived files are marked to skip during job creation.

## Errors

### 400 Bad Request Error

Invalid input

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### DocumentList

- `docType` (enum, optional) — The type of billing document.
  - Allowed values: `Invoice`, `CreditMemo`, `DebitMemo`
- `objectIds` (list of string, optional) — The collection of billing document IDs.

### PostBulkPdfGenerationJobResponseTypeReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### PostBulkPdfGenerationJobResponseTypeSkippedDocumentsItems

- `docType` (enum, optional) — The document type of the skipped document.
  - Allowed values: `Invoice`, `CreditMemo`, `DebitMemo`
- `objectIds` (list of string, optional) — The IDs of the skipped document objects.

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "documents": [
    {}
  ],
  "fileName": "string",
  "indexFileFormat": "JSON"
}
```

**Response**

```json
{
  "success": true,
  "jobId": "402880de8ce7edc3018ce7f18404312a",
  "skippedDocuments": [
    {
      "docType": "Invoice",
      "objectIds": [
        "8a90a04d8e323748018e327b4a0825a0"
      ]
    },
    {
      "docType": "CreditMemo",
      "objectIds": [
        "402880de8ce7edc3018ce7f18404315a"
      ]
    }
  ],
  "createdBy": "2c92c8fb7a2d26b6017a2eaa64c72dea",
  "createdOn": "2024-04-19 05:19:32",
  "fileUrls": "<s3-url>",
  "jobName": "BulkPDFGenerationJobV1",
  "status": "Completed",
  "stepStatus": "PostProcessing"
}
```

**SDK Code**

```python Operations_Create_BulkPDFToZIPGeneration_example
import requests

url = "https://rest.test.zuora.com/v1/operations/bulk-pdf"

payload = {
    "documents": [{}],
    "fileName": "string",
    "indexFileFormat": "JSON"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Operations_Create_BulkPDFToZIPGeneration_example
const url = 'https://rest.test.zuora.com/v1/operations/bulk-pdf';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"documents":[{}],"fileName":"string","indexFileFormat":"JSON"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Operations_Create_BulkPDFToZIPGeneration_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/operations/bulk-pdf"

	payload := strings.NewReader("{\n  \"documents\": [\n    {}\n  ],\n  \"fileName\": \"string\",\n  \"indexFileFormat\": \"JSON\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Operations_Create_BulkPDFToZIPGeneration_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/operations/bulk-pdf")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"documents\": [\n    {}\n  ],\n  \"fileName\": \"string\",\n  \"indexFileFormat\": \"JSON\"\n}"

response = http.request(request)
puts response.read_body
```

```java Operations_Create_BulkPDFToZIPGeneration_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/operations/bulk-pdf")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"documents\": [\n    {}\n  ],\n  \"fileName\": \"string\",\n  \"indexFileFormat\": \"JSON\"\n}")
  .asString();
```

```php Operations_Create_BulkPDFToZIPGeneration_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/operations/bulk-pdf', [
  'body' => '{
  "documents": [
    {}
  ],
  "fileName": "string",
  "indexFileFormat": "JSON"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Operations_Create_BulkPDFToZIPGeneration_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/operations/bulk-pdf");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"documents\": [\n    {}\n  ],\n  \"fileName\": \"string\",\n  \"indexFileFormat\": \"JSON\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Operations_Create_BulkPDFToZIPGeneration_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "documents": [[]],
  "fileName": "string",
  "indexFileFormat": "JSON"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/operations/bulk-pdf")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```